/*
 GAMP - (c) 2001 - Renato R. Santana <rrsantana@yahoo.com>
 
 This module does those essential calls to the sound driver.
   
 This file is part of GAMP, the GNU Amiga Module Player
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
    
 You should have received a copy of the GNU General Public License
 along with This program; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <fcntl.h>
#include <sched.h>

#include <sys/time.h>
#include <sys/times.h>

#include "mod.h"
#include "driver.h"

unsigned long			playtime;
long int				fragsize;

int						start,inc;

struct driver			oss_driver;

int oss_open(void){

	int					dsp_fd;
	long int 			ioparm;
	long				frag;

	audio_buf_info		info;

	
	oss_driver.channels=2;

	/* Some people say that NONBLOCK is necessary for ESS cads. */
	if (!(dsp_fd=open("/dev/dsp", O_WRONLY|O_NONBLOCK))) {
		printf("error opening /dev/dsp");
		exit(1);
	}
	/* Clear O_NONBLOCK again. */
	fcntl(dsp_fd, F_SETFL, 0);
    
	ioparm=8;
	if (ioctl(dsp_fd, SOUND_PCM_WRITE_BITS, &ioparm)==-1){
		printf("error setting sound resolution\n");
		exit(1); 
	}
	oss_driver.bits = ioparm;
	ioparm=2;
	if (ioctl(dsp_fd, SOUND_PCM_WRITE_CHANNELS, &ioparm)==-1){
		
		if (ioctl(dsp_fd, SOUND_PCM_WRITE_CHANNELS, &ioparm)==-1){
			printf("error setting sound channels to 1\n");
			exit(1);
		}
	}
	oss_driver.channels = ioparm;

	ioparm = 8 << 16 | 11;			/* fragments << 16 | (fragsize=2^n) */
	ioctl(dsp_fd, SNDCTL_DSP_SETFRAGMENT, &ioparm);
   	
	ioparm=MIXSPEED;
  	if (ioctl(dsp_fd, SOUND_PCM_WRITE_RATE, &ioparm)==-1){
		printf("error setting sound rate\n");
		exit(1);
	}
	oss_driver.mixspeed = ioparm;
/*
	ioctl(dsp_fd, SNDCTL_DSP_GETOSPACE, &info);

	printf("fragments %d \n", info.fragments);
	printf("fragstotal %d \n", info.fragstotal);
	printf("fragsize %d \n", info.fragsize);
	printf("bytes %d \n", info.bytes);
*/	

	ioctl(dsp_fd, SNDCTL_DSP_GETBLKSIZE, &fragsize);
	oss_driver.fragsize = fragsize;
	oss_driver.fd = dsp_fd;
	return(dsp_fd);
}

int oss_close(void) {
	return (close(oss_driver.fd));
}

